using System;
using System.Data;
using System.Data.SqlClient;
using System.Web;
using System.IO;
using System.Collections;
using System.Text.RegularExpressions;

namespace UUN
{
    /// <summary>
    /// 回贴列表模板的编译部分
    /// </summary>
    public class 编译扩展_回贴列表 : 编译扩展接口
    {
        private SqlConnection 连接;
        private HttpContext HC;
        private 编译器 编译器;

        public 编译扩展_回贴列表(SqlConnection 连接, HttpContext HC, 编译器 编译器)
        {
            this.连接 = 连接;
            this.HC = HC;
            this.编译器 = 编译器;
        }

        private int 回贴列表_一页显示记录数 = 0;

        public String 开始执行代码()
        {
            编译器.方法库 += @"	private String 当前页面;
	//参数
	private int 所属版块;
	private int 贴子ID;
	private bool 是否精华;
	private int 版块页码;
	private int 贴子排序;
	private int 排序;
	//其它
	private String 跳页表单项;
	private String _3G跳页表单项;
	private String 查询条件="""";
	private DataRow 论坛版块;
	private DataSet 论坛版主;
	private String 贴子标题;
	private bool 是否锁定;
	//列表分页
	private int 当前页;
	private int 总页数;
	private int 总记录数;
	private int 一页显示记录数;
	private String 列表跳页(int 页码)
	{
		return Server.HtmlEncode(常用.处理地址(当前页面+""?BID=""+所属版块+""&ID=""+贴子ID+""&bpage=""+版块页码+""&bstate=""+是否精华+""&border=""+贴子排序+""&order=""+排序+""&page=""+页码,访问.用户[""标识""].ToString()));
	}
	private void 获取论坛版块()
	{
		DataSet 论坛版块=(DataSet)Application[""UUN_UUN3G_LunTanBanKuai""];
		for(int i=0;i<论坛版块.Tables[0].Rows.Count;i++)
		{
			DataRow 行=论坛版块.Tables[0].Rows[i];
			if(Convert.ToInt32(行[""ID""])==所属版块)
				this.论坛版块=行;
		}
	}
	private void 生成贴子内容()
	{
		int 回贴模板=0;
		SqlCommand 语句=new SqlCommand(""SELECT [所属版块],[标题],[是否锁定],[模板_" + (编译器.是否WML网页?"":"3G")+ @"回贴列表] FROM [""+程序.数据表前缀+""社区_论坛_贴子] WHERE [是否删除]='0'""+(贴子ID==0?"""":"" AND [ID]=""+贴子ID),访问.连接);
		SqlDataReader 读取=语句.ExecuteReader();
		if(读取.Read())
		{
			所属版块=Convert.ToInt32(读取[""所属版块""]);
			贴子标题=Convert.ToString(读取[""标题""]);
			是否锁定=Convert.ToBoolean(读取[""是否锁定""]);
			回贴模板=Convert.ToInt32(读取[""模板_"+(编译器.是否WML网页?"":"3G")+ @"回贴列表""]);
		}
		else
		{
			读取.Close();
			throw new Exception(""贴子不存在"");
		}
		读取.Close();

		if(File.Exists(Server.MapPath(""~/Template/Club/""+程序.设置[""默认社区模板""]+""/Club_Aspx/""+回贴模板+"".aspx"")))
			Server.Execute(""~/Template/Club/""+程序.设置[""默认社区模板""]+""/Club_Aspx/""+回贴模板+"".aspx"");
	}
	private void 获取论坛版主()
	{
		论坛版主=new DataSet();
		SqlCommand 语句=new SqlCommand(""SELECT * FROM [""+程序.数据表前缀+""社区_论坛_版主] WHERE [所属版块]=""+所属版块+"" ORDER BY [创建时间]"",访问.连接);
		SqlDataAdapter 填充=new SqlDataAdapter(语句);
		填充.Fill(论坛版主,""论坛版主"");
	}
	private bool 是否版主()
	{
		if(论坛版主==null)
			获取论坛版主();
		bool 返回值=false;
		for(int i=0;i<论坛版主.Tables[0].Rows.Count;i++)
			if(Convert.ToInt32(论坛版主.Tables[0].Rows[i][""版主ID""])==Convert.ToInt32(访问.用户[""ID""]))
				返回值=true;
		return 返回值;
	}
	private bool 是否允许回贴()
	{
		if(是否锁定)
			return false;
		switch(Convert.ToInt32(论坛版块[""回贴权限""]))
		{
			case 0:
				return true;
			case 1:
				return 访问.用户[""用户类型""].ToString()==""会员"";
			default:
				return 是否版主();
		}
	}
	private void 应用版块设置()
	{
		if(!Convert.ToBoolean(论坛版块[""版块状态""]))
			throw new Exception(论坛版块[""禁止访问提示""].ToString());
		switch(Convert.ToInt32(论坛版块[""访问权限""]))
		{
			case 0:
				break;
			case 1:
				访问.验证会员();
				break;
			default:
				if(!是否版主())
					throw new Exception(""此版块只允许版主访问"");
				break;
		}
	}
	private String 生成余下全部地址()
	{
		return Server.HtmlEncode(常用.处理地址(当前页面+""?BID=""+所属版块+""&ID=""+贴子ID+""&bpage=""+版块页码+""&bstate=""+是否精华+""&border=""+贴子排序+""&order=""+排序+""&page=""+(当前页+1)+""&yx=1"",访问.用户[""标识""].ToString()));
	}
";
            String 返回值 = "";
            返回值 += @"贴子ID=Convert.ToInt32(Request.QueryString[""ID""]);
		是否精华=Convert.ToBoolean(Request.QueryString[""bstate""]);
		版块页码=Convert.ToInt32(Request.QueryString[""bpage""]);
		贴子排序=Convert.ToInt32(Request.QueryString[""border""]);
		排序=Convert.ToInt32(Request.QueryString[""order""]);
		一页显示记录数=获取一页显示记录数();
		生成贴子内容();
		获取论坛版块();
		应用版块设置();
		当前页面=程序.安装位置+""Club/" + (编译器.是否WML网页?"":"3G_")+ @"Reply.aspx"";
		跳页表单项=""<postfield name=\""ID\"" value=\""""+贴子ID+""\"" />""+
			""<postfield name=\""BID\"" value=\""""+所属版块+""\"" />""+
			""<postfield name=\""bstate\"" value=\""""+是否精华+""\"" />""+
			""<postfield name=\""bpage\"" value=\""""+版块页码+""\"" />""+
			""<postfield name=\""border\"" value=\""""+贴子排序+""\"" />""+
			""<postfield name=\""order\"" value=\""""+排序+""\"" />""+
			""<postfield name=\""""+程序.设置[""标识名称""]+""\"" value=\""""+访问.用户[""标识""]+""\"" />"";
		_3G跳页表单项=""<input type=\""hidden\"" name=\""ID\"" value=\""""+贴子ID+""\"" />""+
			""<input type=\""hidden\"" name=\""BID\"" value=\""""+所属版块+""\"" />""+
			""<input type=\""hidden\"" name=\""bstate\"" value=\""""+是否精华+""\"" />""+
			""<input type=\""hidden\"" name=\""bpage\"" value=\""""+版块页码+""\"" />""+
			""<input type=\""hidden\"" name=\""border\"" value=\""""+贴子排序+""\"" />""+
			""<input type=\""hidden\"" name=\""order\"" value=\""""+排序+""\"" />""+
			""<input type=\""hidden\"" name=\""""+程序.设置[""标识名称""]+""\"" value=\""""+访问.用户[""标识""]+""\"" />"";
";
            返回值 += 生成回贴列表条件(true, "");
            返回值 += "\t\t当前页=Convert.ToInt32(Request.QueryString[\"page\"]);\r\n";
            返回值 += "\t\t总记录数=Convert.ToInt32(数量语句.ExecuteScalar());\r\n";
            返回值 += "\t\t总页数=常用.计算总页数(总记录数,一页显示记录数);\r\n";
            返回值 += "\t\t当前页=常用.计算当前页(总页数,当前页);\r\n";

            return 返回值;
        }

        public String 编译公共标签(String 代码)
        {
            switch (代码)
            {
                case "所属版块":
                    return "\t\t返回值.Append(所属版块);\r\n";
                case "版块名称":
                    return "\t\t返回值.Append(Server.HtmlEncode(论坛版块[\"版块名称\"].ToString()));\r\n";
                case "上级版块地址":
                    return "\t\t返回值.Append(Server.HtmlEncode(常用.处理地址(程序.安装位置+\"Club/" + (编译器.是否WML网页 ? "" : "3G_") + "Board.aspx?ID=\"+所属版块+\"&state=\"+是否精华+\"&order=\"+贴子排序+\"&page=\"+版块页码,访问.用户[\"标识\"].ToString())));\r\n";
                case "贴子ID":
                    return "\t\t返回值.Append(贴子ID);\r\n";
                case "贴子标题":
                    return "\t\t返回值.Append(Server.HtmlEncode(贴子标题));\r\n";
                case "贴子地址":
                    return "\t\t返回值.Append(Server.HtmlEncode(常用.处理地址(程序.安装位置+\"Club/" + (编译器.是否WML网页 ? "" : "3G_") + "Topic.aspx?BID=\"+所属版块+\"&ID=\"+贴子ID+\"&bpage=\"+版块页码+\"&bstate=\"+是否精华+\"&border=\"+贴子排序,访问.用户[\"标识\"].ToString())));\r\n";
                case "当前页":
                    return "\t\t返回值.Append(当前页);\r\n";
                case "总页数":
                    return "\t\t返回值.Append(总页数);\r\n";
                case "总记录数":
                    return "\t\t返回值.Append(总记录数);\r\n";
                case "允许回贴":
                    return "\t\tif(是否允许回贴())\r\n" +
                        "\t\t{\r\n";
                case "/允许回贴":
                    return "\r\n\t\t}\r\n";
                case "禁止回贴":
                    return @"		if(!是否允许回贴())
		{
";
                case "/禁止回贴":
                    return @"
		}
";
                default:
                    return "";
            }
        }

        private String 编译模板方法_上级版块列表(int 排序, String 代码)
        {
            String 返回值 = "";
            String 随机值 = 常用.随机字符(8);
            编译器.方法库 += "\tprivate String 生成上级版块列表" + 随机值 + "(DataSet 数据,int ID)\r\n";
            编译器.方法库 += "\t{\r\n";
            编译器.方法库 += "\t\tif(ID!=0)\r\n";
            编译器.方法库 += "\t\t{\r\n";
            编译器.方法库 += "\t\t\tString 返回值=\"\";\r\n";
            编译器.方法库 += "\t\t\tString 版块名称=\"\";\r\n";
            编译器.方法库 += "\t\t\tint 上级版块=0;\r\n";
            编译器.方法库 += "\t\t\tfor(int i=0;i<数据.Tables[0].Rows.Count;i++)\r\n";
            编译器.方法库 += "\t\t\t{\r\n";
            编译器.方法库 += "\t\t\t\tDataRow 行=数据.Tables[0].Rows[i];\r\n";
            编译器.方法库 += "\t\t\t\tif(Convert.ToInt32(行[\"ID\"])==ID)\r\n";
            编译器.方法库 += "\t\t\t\t{\r\n";
            编译器.方法库 += "\t\t\t\t\t版块名称=Convert.ToString(行[\"版块名称\"]);\r\n";
            编译器.方法库 += "\t\t\t\t\t上级版块=Convert.ToInt32(行[\"所属版块\"]);\r\n";
            编译器.方法库 += "\t\t\t\t}\r\n";
            编译器.方法库 += "\t\t\t}\r\n";
            Hashtable 属性列表 = new Hashtable();
            属性列表.Add("版块名称", "Server.HtmlEncode(版块名称)");
            属性列表.Add("地址", @"Server.HtmlEncode(常用.处理地址(程序.安装位置+""Club/" + (编译器.是否WML网页 ? "" : "3G_") + @"Board.aspx?ID=""+ID,访问.用户[""标识""].ToString()))");
            编译器.方法库 += 编译器.生成代码项(属性列表, 代码, "返回值");
            if (排序 == 0)
                编译器.方法库 += "\t\t\t\treturn 生成上级版块列表" + 随机值 + "(数据,上级版块)+返回值;\r\n";
            else
                编译器.方法库 += "\t\t\t\treturn 返回值+生成上级版块列表" + 随机值 + "(数据,上级版块);\r\n";
            编译器.方法库 += "\t\t}\r\n";
            编译器.方法库 += "\t\telse\r\n";
            编译器.方法库 += "\t\t{\r\n";
            编译器.方法库 += "\t\t\treturn \"\";\r\n";
            编译器.方法库 += "\t\t}\r\n";
            编译器.方法库 += "\t}\r\n";
            返回值 += "\t\tif(所属版块!=0)\r\n";
            返回值 += "\t\t{\r\n";
            返回值 += "\t\t\tDataSet 数据" + 随机值 + "=(DataSet)Application[\"UUN_UUN3G_LunTanBanKuai\"];\r\n";
            返回值 += "\t\t\t返回值.Append(生成上级版块列表" + 随机值 + "(数据" + 随机值 + ",所属版块));\r\n";
            返回值 += "\t\t}\r\n";
            return 返回值;
        }

        private String 编译模板方法_回贴列表(int 字数, String 时间格式, String 格式, String 交替格式, String 空记录代码)
        {
            String 随机值 = 常用.随机字符(8);

            Hashtable 必须字段 = new Hashtable();
            必须字段.Add("序号", "");
            必须字段.Add("回贴列表地址", "所属版块,ID");
            必须字段.Add("版块地址", "所属版块");
            必须字段.Add("版块名称", "所属版块");
            必须字段.Add("回贴用户地址", "回贴用户ID");
            必须字段.Add("贴子地址", "所属版块,贴子ID");
            必须字段.Add("支持地址", "ID");
            必须字段.Add("反对地址", "ID");
            Hashtable 字段代码 = new Hashtable();
            字段代码.Add("序号", "(当前页-1)*一页显示记录+i+1");
            字段代码.Add("回贴列表地址", @"Server.HtmlEncode(常用.处理地址(程序.安装位置+""Club/" + (编译器.是否WML网页 ? "" : "3G_") + @"Reply.aspx?BID=""+行[""所属版块""]+""&ID=""+行[""ID""],访问.用户[""标识""].ToString()))");
            字段代码.Add("版块地址", @"Server.HtmlEncode(常用.处理地址(程序.安装位置+""Club/" + (编译器.是否WML网页 ? "" : "3G_") + @"Board.aspx?ID=""+行[""所属版块""],访问.用户[""标识""].ToString()))");
            字段代码.Add("版块名称", @"常用.获取版块名称(Convert.ToInt32(行[""所属版块""]))");
            字段代码.Add("回贴用户地址", @"Server.HtmlEncode(常用.处理地址(程序.安装位置+""Club/" + (编译器.是否WML网页 ? "" : "3G_") + @"User.aspx?ID=""+行[""回贴用户ID""]+""&rurl=""+Server.UrlEncode(Request.Url.ToString()),访问.用户[""标识""].ToString()))");
            字段代码.Add("回贴用户昵称", @"Server.HtmlEncode(行[""回贴用户昵称""].ToString())");
            字段代码.Add("回贴用户IP", @"行[""回贴用户IP""].ToString()==""""?"""":行[""回贴用户IP""].ToString().Substring(0,行[""回贴用户IP""].ToString().Length-4)+""****""");
            字段代码.Add("回贴用户地区", @"Server.HtmlEncode(行[""回贴用户地区""].ToString())");
            字段代码.Add("贴子地址", @"Server.HtmlEncode(常用.处理地址(程序.安装位置+""Club/" + (编译器.是否WML网页 ? "" : "3G_") + @"Topic.aspx?BID=""+行[""所属版块""]+""&ID=""+行[""贴子ID""],访问.用户[""标识""].ToString()))");
            字段代码.Add("贴子标题", @"Server.HtmlEncode(行[""贴子标题""].ToString())");
            字段代码.Add("贴子内容", @"Server.HtmlEncode(常用.截取字符串(行[""回贴内容""].ToString()," + 字数 + "))");
            字段代码.Add("支持地址", @"Server.HtmlEncode(常用.处理地址(程序.安装位置+""Club/" + (编译器.是否WML网页 ? "" : "3G_") + @"Reply_Case.aspx?z=true&ID=""+行[""ID""],访问.用户[""标识""].ToString()))");
            字段代码.Add("反对地址", @"Server.HtmlEncode(常用.处理地址(程序.安装位置+""Club/" + (编译器.是否WML网页 ? "" : "3G_") + @"Reply_Case.aspx?z=false&ID=""+行[""ID""],访问.用户[""标识""].ToString()))");
            字段代码.Add("发表时间", @"Convert.ToDateTime(行[""发表时间""]).ToString(""" + 时间格式 + "\")");

            String 查询字段, 行代码;
            查询字段 = 编译器.生成查询字段(格式, 交替格式, 必须字段, 字段代码, out 行代码);

            编译器.方法库 += "\tprivate void 回贴列表" + 随机值 + @"()
	{
		if(总记录数<1)
			返回值.Append(@"""+空记录代码.Replace("\"","\"\"")+@""");
";
            编译器.方法库 += 生成回贴列表条件(false, 查询字段);
            编译器.方法库 += 生成查询结果列表(行代码);

            return "\t\t回贴列表" + 随机值 + "();\r\n";
        }
        private String 生成查询结果列表(String 行代码)
        {
            String 返回值 = "";
            返回值 += "\t\tDataSet 数据=new DataSet();\r\n";
            返回值 += "\t\tSqlDataAdapter 填充=new SqlDataAdapter(语句);\r\n";
            返回值 += "\t\t填充.Fill(数据,(当前页-1)*一页显示记录数,一页显示记录数,\"表\");\r\n";
            返回值 += "\t\tfor(int i=0;i<数据.Tables[0].Rows.Count;i++)\r\n";
            返回值 += "\t\t{\r\n";
            返回值 += 行代码;
            返回值 += "\t\t}\r\n";
            返回值 += "\t\t}\r\n";
            return 返回值;
        }

        private String 编译模板方法_列表分页(int ID, String 无分页代码)
        {
            return 编译器.编译内容分页(
                "Club",
                "Page", ID, 无分页代码);
        }

        private String 编译模板方法_分页设置(int 一页显示记录数)
        {
            if (一页显示记录数 > 0)
                回贴列表_一页显示记录数 = 一页显示记录数;
            return "";
        }

        public String 编译模板方法(String 方法名称, String[] 属性数组)
        {
            switch (方法名称)
            {
                case "上级版块列表":
                    return 编译模板方法_上级版块列表(Convert.ToInt32(属性数组[0]),
                        属性数组[1]);
                case "_回贴列表":
                    return 编译模板方法_回贴列表(Convert.ToInt32(属性数组[0]),
                        属性数组[1],
                        属性数组[2],
                        属性数组[3],
                        属性数组[4]);
                case "列表分页":
                    return 编译模板方法_列表分页(Convert.ToInt32(属性数组[0]),
                        属性数组[1]);
                case "分页设置":
                    return 编译模板方法_分页设置(Convert.ToInt32(属性数组[0]));
                default:
                    return "";
            }
        }



        public string 结束执行代码()
        {
            编译器.方法库 += @"	private int 获取一页显示记录数()
	{
";
            if (回贴列表_一页显示记录数 == 0)
                编译器.方法库 += "\t\treturn 访问.获取一页显示记录数();\r\n";
            else
                编译器.方法库 += "\t\treturn " + 回贴列表_一页显示记录数 + ";\r\n";
            编译器.方法库 += @"
	}
";
            return "";
        }


        private String 生成回贴列表条件(bool 是否数量, String 查询字段)
        {
            String 返回值 = "";
            String 语句名称 = 是否数量 ? "数量语句" : "语句";
            if (是否数量)
                返回值 += @"		查询条件+="" WHERE [贴子ID]=""+贴子ID;
";
            返回值 += "\t\tString " + 语句名称 + "SQL=\"SELECT " + (是否数量 ? "COUNT(ID)" : 查询字段) + " FROM [\"+程序.数据表前缀+\"社区_论坛_回贴]\"+查询条件;\r\n";
            if (!是否数量)
                返回值 += @"		" + 语句名称 + @"SQL+="" ORDER BY "";
		switch(排序)
		{
			case 0:
				" + 语句名称 + @"SQL+=""[ID]"";
				break;
			case 1:
				" + 语句名称 + @"SQL+=""[ID] DESC"";
				break;
			case 2:
				" + 语句名称 + @"SQL+=""[支持] DESC,[反对] DESC"";
				break;
			default:
				" + 语句名称 + @"SQL+=""[反对] DESC,[支持] DESC"";
				break;
		}
";
            返回值 += "\t\tSqlCommand " + 语句名称 + "=new SqlCommand(" + 语句名称 + "SQL,访问.连接);\r\n";
            return 返回值;
        }
    }
}